//  
//  MNSettings.cs
//  
//  Author:
//       Ala Hadid <ahdsoftwares@hotmail.com>
// 
//  Copyright (c) Ala Hadid 2011 
// 
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace MyNesGTK
{
	public class MNSettings
	{
		public bool Fullscreen= false;
		public bool Resizable = true;
		public int sizeX = 2;//to make screen size= (256 * X) * (240 * X)
		public string TVFormat="auto";//can be auto, pal or ntsc
		public string StateFolder="";//
		public string SnapsFolder="";//
		public string LastOpenedRom= "";
		public bool EnableSound= true;
		public bool NoLimiter= false;
		public string ReplaceSpacesWith="";
		//keys
		public string key_P1_A="x";
		public string key_P1_B="z";
		public string key_P1_SE="c";
		public string key_P1_ST="v";
		public string key_P1_UP="UpArrow";
		public string key_P1_LF="LeftArrow";
		public string key_P1_RT="RightArrow";
		public string key_P1_DO="DownArrow";
		
		public string key_P2_A="j";
		public string key_P2_B="h";
		public string key_P2_SE="y";
		public string key_P2_ST="u";
		public string key_P2_UP="w";
		public string key_P2_LF="a";
		public string key_P2_RT="d";
		public string key_P2_DO="s";

		public string key_P3_A="";
		public string key_P3_B="";
		public string key_P3_SE="";
		public string key_P3_ST="";
		public string key_P3_UP="";
		public string key_P3_LF="";
		public string key_P3_RT="";
		public string key_P3_DO="";
		
		public string key_P4_A="";
		public string key_P4_B="";
		public string key_P4_SE="";
		public string key_P4_ST="";
		public string key_P4_UP="";
		public string key_P4_LF="";
		public string key_P4_RT="";
		public string key_P4_DO="";

		public string key_TogglePause="f2";
		public string key_SoftReset="f3";
		public string key_TakeSnapshot="f5";
		public string key_SaveState="f6";
		public string key_LoadState="f9";
		public string key_NoLimiter="f7";
		public string key_ToggleFullscreen="f12";

		
		public MNSettings ()
		{
	    }
		public void LoadSettings()
		{
	    	if (File.Exists(System.IO.Path.Combine(MyNesGTK.MainClass.StartUpFolder, "config")))
			{
				string [] lines = File.ReadAllLines(System.IO.Path.Combine(MyNesGTK.MainClass.StartUpFolder, "config"));
				if (lines[0]!="[MyNesGTK]")
					return;
				for (int i=1;i<lines.Length;i++)
				{
					if (lines[i]!="")
					{
					if (lines[i].Contains("="))
					{
						string []cm=lines[i].ToString().Split(new char[]{'='});
						switch (cm[0].ToString().ToLower())
						{
						    case "fullscreen":Fullscreen=bool.Parse(cm[1]); break;
						    case "resizable":Resizable=bool.Parse(cm[1]); break;
						    case "sizex":sizeX=int.Parse(cm[1]); break;
						    case "tvformat":TVFormat=cm[1]; break;
						    case "statefolder":StateFolder=cm[1]; break;
						    case "snapsfolder":SnapsFolder=cm[1]; break;
							case "lastopenedrom":LastOpenedRom=cm[1]; break;
							case "enablesound":EnableSound=bool.Parse(cm[1]); break;
							case "nolimiter":NoLimiter=bool.Parse(cm[1]); break;
						    case "replacespaceswith":ReplaceSpacesWith=cm[1]; break;
								
							case "key_p1_a":key_P1_A=cm[1]; break;
							case "key_p1_b":key_P1_B=cm[1]; break;
							case "key_p1_se":key_P1_SE=cm[1]; break;
							case "key_p1_st":key_P1_ST=cm[1]; break;
							case "key_p1_up":key_P1_UP=cm[1]; break;
							case "key_p1_lf":key_P1_LF=cm[1]; break;
							case "key_p1_rt":key_P1_RT=cm[1]; break;
							case "key_p1_do":key_P1_DO=cm[1]; break;
							
							case "key_p2_s":key_P2_A=cm[1]; break;
							case "key_p2_b":key_P2_B=cm[1]; break;
							case "key_p2_se":key_P2_SE=cm[1]; break;
							case "key_p2_st":key_P2_ST=cm[1]; break;
							case "key_p2_up":key_P2_UP=cm[1]; break;
							case "key_p2_lf":key_P2_LF=cm[1]; break;
							case "key_p2_rt":key_P2_RT=cm[1]; break;
							case "key_p2_do":key_P2_DO=cm[1]; break;

							case "key_p3_a":key_P3_A=cm[1]; break;
							case "key_p3_b":key_P3_B=cm[1]; break;
							case "key_p3_se":key_P3_SE=cm[1]; break;
							case "key_p3_st":key_P3_ST=cm[1]; break;
							case "key_p3_up":key_P3_UP=cm[1]; break;
							case "key_p3_lf":key_P3_LF=cm[1]; break;
							case "key_p3_rt":key_P3_RT=cm[1]; break;
							case "key_p3_do":key_P3_DO=cm[1]; break;
							
							case "key_p4_s":key_P4_A=cm[1]; break;
							case "key_p4_b":key_P4_B=cm[1]; break;
							case "key_p4_se":key_P4_SE=cm[1]; break;
							case "key_p4_st":key_P4_ST=cm[1]; break;
							case "key_p4_up":key_P4_UP=cm[1]; break;
							case "key_p4_lf":key_P4_LF=cm[1]; break;
							case "key_p4_rt":key_P4_RT=cm[1]; break;
							case "key_p4_do":key_P4_DO=cm[1]; break;

							case "key_togglepause":key_TogglePause=cm[1]; break;
							case "key_softreset":key_SoftReset=cm[1]; break;
							case "key_takesnapshot":key_TakeSnapshot=cm[1]; break;
							case "key_savestate":key_SaveState=cm[1]; break;
							case "key_loadstate":key_LoadState=cm[1]; break;
							case "key_nolimiter":key_NoLimiter=cm[1]; break;
							case "key_togglefullscreen":key_ToggleFullscreen=cm[1]; break;
						}
					}
				 }
				}
			}
		}
		public void SaveSettings()
		{
			//we'll use simple configuration file for linux
			//users
	    	List<string > lines= new List<string>();
			lines.Add("[MyNesGTK]");
			lines.Add("fullscreen="+Fullscreen.ToString());
			lines.Add("resizable="+Resizable.ToString());
			lines.Add("sizex="+sizeX.ToString());
			lines.Add("tvformat="+TVFormat.ToString());
			lines.Add("statefolder="+StateFolder);
			lines.Add("snapsfolder="+SnapsFolder);
			lines.Add("lastopenedrom="+LastOpenedRom);
			lines.Add("enablesound="+EnableSound);
			lines.Add("nolimiter="+NoLimiter);
			lines.Add("ReplaceSpacesWith="+ReplaceSpacesWith);
			
			lines.Add("key_P1_A="+key_P1_A);
			lines.Add("key_P1_B="+key_P1_B);
			lines.Add("key_P1_SE="+key_P1_SE);
			lines.Add("key_P1_ST="+key_P1_ST);
			lines.Add("key_P1_UP="+key_P1_UP);
			lines.Add("key_P1_LF="+key_P1_LF);
			lines.Add("key_P1_RT="+key_P1_RT);
			lines.Add("key_P1_DO="+key_P1_DO);
			
			lines.Add("key_P2_A="+key_P2_A);
			lines.Add("key_P2_B="+key_P2_B);
			lines.Add("key_P2_SE="+key_P2_SE);
			lines.Add("key_P2_ST="+key_P2_ST);
			lines.Add("key_P2_UP="+key_P2_UP);
			lines.Add("key_P2_LF="+key_P2_LF);
			lines.Add("key_P2_RT="+key_P2_RT);
			lines.Add("key_P2_DO="+key_P2_DO);

			lines.Add("key_P3_A="+key_P3_A);
			lines.Add("key_P3_B="+key_P3_B);
			lines.Add("key_P3_SE="+key_P3_SE);
			lines.Add("key_P3_ST="+key_P3_ST);
			lines.Add("key_P3_UP="+key_P3_UP);
			lines.Add("key_P3_LF="+key_P3_LF);
			lines.Add("key_P3_RT="+key_P3_RT);
			lines.Add("key_P3_DO="+key_P3_DO);
			
			lines.Add("key_P4_A="+key_P4_A);
			lines.Add("key_P4_B="+key_P4_B);
			lines.Add("key_P4_SE="+key_P4_SE);
			lines.Add("key_P4_ST="+key_P4_ST);
			lines.Add("key_P4_UP="+key_P4_UP);
			lines.Add("key_P4_LF="+key_P4_LF);
			lines.Add("key_P4_RT="+key_P4_RT);
			lines.Add("key_P4_DO="+key_P4_DO);
			
			lines.Add("key_TogglePause="+key_TogglePause);
			lines.Add("key_SoftReset="+key_SoftReset);
			lines.Add("key_TakeSnapshot="+key_TakeSnapshot);
			lines.Add("key_SaveState="+key_SaveState);
			lines.Add("key_LoadState="+key_LoadState);
			lines.Add("key_NoLimiter="+key_NoLimiter);
			lines.Add("key_ToggleFullscreen="+key_ToggleFullscreen);
			//write to file
			File.WriteAllLines(System.IO.Path.Combine(MyNesGTK.MainClass.StartUpFolder, "config"),lines.ToArray());
		}
	}
}

