//  
//  MainClass.cs
//  
//  Author:
//       Ala Hadid <ahdsoftwares@hotmail.com>
// 
//  Copyright (c) Ala Hadid 2011 
// 
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
using System;
using System.IO;
using Gtk;
using System.Reflection;
using MyNes.Nes.Database;

namespace MyNesGTK
{
	class MainClass
	{
	    static MyNesGTK.MNSettings settings = new MyNesGTK.MNSettings ();
	    public static string StartUpFolder="";
		public static void Main (string[] args)
		{
			Application.Init ();
			StartUpFolder=System.IO.Path.GetDirectoryName( Assembly.GetExecutingAssembly().Location);
			settings.StateFolder=System.IO.Path.Combine(StartUpFolder, "statesaves");
		    settings.SnapsFolder=System.IO.Path.Combine(StartUpFolder, "snapshots");
		
			settings.LoadSettings();
			MyNes.Nes.MapperManager.Cache();

			if (File.Exists(".\\database.xml"))
                NesDatabase.LoadDatabase(new FileStream(".\\database.xml", FileMode.Open, FileAccess.Read));

			MainWindow win = new MainWindow (args);
			win.Show ();
			Application.Run ();
			
		}
		public static MyNesGTK.MNSettings Setting
		{
			get { return settings; }
		}
		public static string Version
        {
            get { return Assembly.GetExecutingAssembly().GetName().Version.ToString(); }
        }
	}
}
