//  
//  MainWindow.cs
//  
//  Author:
//       Ala Hadid <ahdsoftwares@hotmail.com>
// 
//  Copyright (c) Ala Hadid 2011 
// 
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
using System;
using System.Diagnostics;
using Gtk;

public partial class MainWindow: Gtk.Window
{	
	public MainWindow (string[] args): base (Gtk.WindowType.Toplevel)
	{
		Build ();
		//load settings
		FullscreenAction1.Active=MyNesGTK.MainClass.Setting.Fullscreen;
		ResizableAction2.Active=MyNesGTK.MainClass.Setting.Resizable;
		EnableSoundAction.Active=MyNesGTK.MainClass.Setting.EnableSound;
		NoLimiterAction.Active=MyNesGTK.MainClass.Setting.NoLimiter;
		
		switch (MyNesGTK.MainClass.Setting.sizeX)
		{
		    case 1:	x1Action.Activate(); break;
			case 2:	x2Action.Activate(); break;
			case 3:	x3Action.Activate(); break;
			case 4:	x4Action.Activate(); break;
			case 5:	x5Action.Activate(); break;
			case 6:	x6Action.Activate(); break;
		}
		switch (MyNesGTK.MainClass.Setting.TVFormat)
		{
		    case "auto":AutoAction.Active=true; PALAction.Visible=false; break;
		    case "pal":PALAction.Active=true;   break;
	  	}
		if (args.Length > 0)
			OpenRom(args);
	}
	void OpenRom(string fileName)
	{
		 try 
			{
				//set settings
				string args =fileName;
				if (MyNesGTK.MainClass.Setting.ReplaceSpacesWith !="")
				    args.Replace(" ", MyNesGTK.MainClass.Setting.ReplaceSpacesWith);
		        if (MyNesGTK.MainClass.Setting.Fullscreen)
					args+=" /fullscreen";
				if (MyNesGTK.MainClass.Setting.Resizable)
					args+=" /resizable";
		    	if (MyNesGTK.MainClass.Setting.NoLimiter)
					args+=" /nolimiter";
				switch (MyNesGTK.MainClass.Setting.TVFormat)
				{
				    case "auto": args+=" /tv_auto"; break;
					case "pal": args+=" /tv_pal"; break;
					case "ntsc": args+=" /tv_ntsc"; break;
				}
				args+=" /w"+(MyNesGTK.MainClass.Setting.sizeX*256).ToString();
				args+=" /h"+(MyNesGTK.MainClass.Setting.sizeX*240).ToString();
				
				//controls
				args+=" /p1_a="+MyNesGTK.MainClass.Setting.key_P1_A;
				args+=" /p1_b="+MyNesGTK.MainClass.Setting.key_P1_B;
				args+=" /p1_do="+MyNesGTK.MainClass.Setting.key_P1_DO;
                args+=" /p1_lf="+MyNesGTK.MainClass.Setting.key_P1_LF;
			    args+=" /p1_rt="+MyNesGTK.MainClass.Setting.key_P1_RT;
			    args+=" /p1_se="+MyNesGTK.MainClass.Setting.key_P1_SE;
			    args+=" /p1_st="+MyNesGTK.MainClass.Setting.key_P1_ST;
				args+=" /p1_up="+MyNesGTK.MainClass.Setting.key_P1_UP;
				
				args+=" /p2_a="+MyNesGTK.MainClass.Setting.key_P2_A;
				args+=" /p2_b="+MyNesGTK.MainClass.Setting.key_P2_B;
				args+=" /p2_do="+MyNesGTK.MainClass.Setting.key_P2_DO;
                args+=" /p2_lf="+MyNesGTK.MainClass.Setting.key_P2_LF;
			    args+=" /p2_rt="+MyNesGTK.MainClass.Setting.key_P2_RT;
			    args+=" /p2_se="+MyNesGTK.MainClass.Setting.key_P2_SE;
			    args+=" /p2_st="+MyNesGTK.MainClass.Setting.key_P2_ST;
				args+=" /p2_up="+MyNesGTK.MainClass.Setting.key_P2_UP;

				args+=" /p3_a="+MyNesGTK.MainClass.Setting.key_P3_A;
				args+=" /p3_b="+MyNesGTK.MainClass.Setting.key_P3_B;
				args+=" /p3_do="+MyNesGTK.MainClass.Setting.key_P3_DO;
                args+=" /p3_lf="+MyNesGTK.MainClass.Setting.key_P3_LF;
			    args+=" /p3_rt="+MyNesGTK.MainClass.Setting.key_P3_RT;
			    args+=" /p3_se="+MyNesGTK.MainClass.Setting.key_P3_SE;
			    args+=" /p3_st="+MyNesGTK.MainClass.Setting.key_P3_ST;
				args+=" /p3_up="+MyNesGTK.MainClass.Setting.key_P3_UP;
				
				args+=" /p4_a="+MyNesGTK.MainClass.Setting.key_P4_A;
				args+=" /p4_b="+MyNesGTK.MainClass.Setting.key_P4_B;
				args+=" /p4_do="+MyNesGTK.MainClass.Setting.key_P4_DO;
                args+=" /p4_lf="+MyNesGTK.MainClass.Setting.key_P4_LF;
			    args+=" /p4_rt="+MyNesGTK.MainClass.Setting.key_P4_RT;
			    args+=" /p4_se="+MyNesGTK.MainClass.Setting.key_P4_SE;
			    args+=" /p4_st="+MyNesGTK.MainClass.Setting.key_P4_ST;
				args+=" /p4_up="+MyNesGTK.MainClass.Setting.key_P4_UP;

				args+=" /key_pause="+MyNesGTK.MainClass.Setting.key_TogglePause;
			    args+=" /key_statesave="+MyNesGTK.MainClass.Setting.key_SaveState;
			    args+=" /key_softreset="+MyNesGTK.MainClass.Setting.key_SoftReset;
			    args+=" /key_takesnap="+MyNesGTK.MainClass.Setting.key_TakeSnapshot;
				args+=" /key_stateload="+MyNesGTK.MainClass.Setting.key_LoadState;
				args+=" /key_nolimiter="+MyNesGTK.MainClass.Setting.key_NoLimiter;
				args+=" /key_fullscreen="+MyNesGTK.MainClass.Setting.key_ToggleFullscreen;
				
			    if (!MyNesGTK.MainClass.Setting.EnableSound)
					args+=" /sound_off";

	            MyNesSDL.MyNesSDL sdl = new MyNesSDL.MyNesSDL(args.Split(new char[]{' '}));
		    }
			catch(Exception ex)
		{Console.WriteLine(ex.ToString());}
	}
	void OpenRom(string[] args)
	{
	    MyNesSDL.MyNesSDL sdl=new MyNesSDL.MyNesSDL(args);
	}
	protected void OnDeleteEvent (object sender, DeleteEventArgs a)
	{
		MyNesGTK.MainClass.Setting.SaveSettings();
		Application.Quit ();
		a.RetVal = true;
	}

	protected void OnOpenActionActivated (object sender, System.EventArgs e)
	{
		Gtk.FileChooserDialog fc =
		new Gtk.FileChooserDialog("Open nes rom",
		                            this,
		                            FileChooserAction.Open,
		                            Gtk.Stock.Cancel,ResponseType.Cancel,
		                            Gtk.Stock.Open,ResponseType.Accept);
		FileFilter filter = new FileFilter();
		filter.Name = "INES rom (*.nes)";
		filter.AddMimeType("Ines");
		filter.AddPattern("*.nes");
		fc.AddFilter(filter);
		if (MyNesGTK.MainClass.Setting.LastOpenedRom !=null)
			fc.SetFilename(MyNesGTK.MainClass.Setting.LastOpenedRom);

		if (fc.Run() == (int)ResponseType.Accept) 
		{
			MyNesGTK.MainClass.Setting.LastOpenedRom=fc.Filename;
			string fname=fc.Filename;
			fc.Destroy();
			OpenRom(fname);
		}
		else
		{  fc.Destroy(); }
	}

	protected void OnFullscreenAction1Toggled (object sender, System.EventArgs e)
	{
		MyNesGTK.MainClass.Setting.Fullscreen=FullscreenAction1.Active;
	}

	protected void OnX1ActionToggled (object sender, System.EventArgs e)
	{
		MyNesGTK.MainClass.Setting.sizeX=1;
	}

	protected void OnX2ActionToggled (object sender, System.EventArgs e)
	{	
		MyNesGTK.MainClass.Setting.sizeX=2;
	}

	protected void OnX3ActionToggled (object sender, System.EventArgs e)
	{
		MyNesGTK.MainClass.Setting.sizeX=3;
	}

	protected void OnX4ActionToggled (object sender, System.EventArgs e)
	{
	    MyNesGTK.MainClass.Setting.sizeX=4;
	}

	protected void OnX5ActionToggled (object sender, System.EventArgs e)
	{
		MyNesGTK.MainClass.Setting.sizeX=5;
	}

	protected void OnX6ActionToggled (object sender, System.EventArgs e)
	{
		MyNesGTK.MainClass.Setting.sizeX=6;
	}

	protected void OnResizableAction2Toggled (object sender, System.EventArgs e)
	{
		MyNesGTK.MainClass.Setting.Resizable=ResizableAction2.Active;
	}

	protected void OnQuitActionActivated (object sender, System.EventArgs e)
	{
		MyNesGTK.MainClass.Setting.SaveSettings();
		Application.Quit ();
	}

	protected void OnFoldersAction1Activated (object sender, System.EventArgs e)
	{
		 MyNesGTK.Window_Folders win=new MyNesGTK.Window_Folders();
		 win.Parent=this;
	}

	protected void OnHelpActionActivated (object sender, System.EventArgs e)
	{
		try
		{
			Process.Start("HELP");
		}
		catch{}
	}

	protected void OnControlsActionActivated (object sender, System.EventArgs e)
	{
		 MyNesGTK.Window_Controls win=new MyNesGTK.Window_Controls();
		 win.Parent=this;
	}

	protected void OnAboutMyNesActionActivated (object sender, System.EventArgs e)
	{
		MyNesGTK.AboutWindow ab=new MyNesGTK.AboutWindow ();
		ab.Run();
	}

	protected void OnEnableSoundActionToggled (object sender, System.EventArgs e)
	{
	     MyNesGTK.MainClass.Setting.EnableSound=EnableSoundAction.Active;
	}

	protected void OnNoLimiterActionToggled (object sender, System.EventArgs e)
	{
		 MyNesGTK.MainClass.Setting.NoLimiter = NoLimiterAction.Active;
	}

	protected void OnAutoActionToggled (object sender, System.EventArgs e)
	{
		if (AutoAction.Active)
		{
			MyNesGTK.MainClass.Setting.TVFormat="auto";
			PALAction.Visible=false;
		}
		else
		{
			MyNesGTK.MainClass.Setting.TVFormat=PALAction.Active?"pal":"ntsc";
			PALAction.Visible=true;
		}
	}

	protected void OnPALActionToggled (object sender, System.EventArgs e)
	{
	    MyNesGTK.MainClass.Setting.TVFormat=PALAction.Active?"pal":"ntsc";
	}

	protected void OnOtherActionActivated (object sender, System.EventArgs e)
	{
		MyNesGTK.Window_OtherOptions op=new MyNesGTK.Window_OtherOptions();
		op.Run();
	}
}
