﻿//  
//  InputManager.cs
//  
//  Author:
//       Ala Hadid <ahdsoftwares@hotmail.com>
// 
//  Copyright (c) Ala Hadid 2011 
// 
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MyNes.Nes.Input;
using SdlDotNet.Input;
using SdlDotNet.Core;

namespace MyNesSDL
{
    public class InputManager : IInputDevice
    {
        public Joypad joypad1;
        public Joypad joypad2;
		public Joypad joypad3;
        public Joypad joypad4;
		public VSUnisystemSDL vsunisystem;
		//keys
	    public Key p1_A = Key.X; 
		public Key p1_B = Key.Z; 
	    public Key p1_ST = Key.V;
		public Key p1_SE = Key.C;
	    public Key p1_UP = Key.UpArrow;
	    public Key p1_DO = Key.DownArrow;
		public Key p1_LF = Key.LeftArrow;
		public Key p1_RT = Key.RightArrow;
		
        public Key p2_A = Key.K; 
		public Key p2_B = Key.J; 
	    public Key p2_ST = Key.I;
		public Key p2_SE = Key.U;
	    public Key p2_UP = Key.W;
	    public Key p2_DO = Key.S;
		public Key p2_LF = Key.A;
		public Key p2_RT = Key.D;

		public Key p3_A = Key.Escape; 
		public Key p3_B = Key.Escape; 
	    public Key p3_ST = Key.Escape;
		public Key p3_SE = Key.Escape;
	    public Key p3_UP = Key.Escape;
	    public Key p3_DO = Key.Escape;
		public Key p3_LF = Key.Escape;
		public Key p3_RT = Key.Escape;
		
        public Key p4_A = Key.Escape; 
		public Key p4_B = Key.Escape; 
	    public Key p4_ST = Key.Escape;
		public Key p4_SE = Key.Escape;
	    public Key p4_UP = Key.Escape;
	    public Key p4_DO = Key.Escape;
		public Key p4_LF = Key.Escape;
		public Key p4_RT = Key.Escape;

		public Key vsu_CreditServiceButton =Key.End;
        public Key vsu_DIPSwitch1  =(Key.Keypad1| Key.LeftControl);
        public Key vsu_DIPSwitch2  =(Key.Keypad2| Key.LeftControl);
        public Key vsu_DIPSwitch3  =(Key.Keypad3| Key.LeftControl);
        public Key vsu_DIPSwitch4  =(Key.Keypad4| Key.LeftControl);
        public Key vsu_DIPSwitch5  =(Key.Keypad5| Key.LeftControl);
        public Key vsu_DIPSwitch6  =(Key.Keypad6| Key.LeftControl);
        public Key vsu_DIPSwitch7  =(Key.Keypad7| Key.LeftControl);
        public Key vsu_DIPSwitch8  =(Key.Keypad8| Key.LeftControl);
        public Key vsu_CreditLeftCoinSlot  =Key.Insert;
        public Key vsu_CreditRightCoinSlot =Key.Home;
		
        public InputManager(Joypad joypad1, Joypad joypad2,Joypad joypad3, Joypad joypad4)
        {
            this.joypad1 = joypad1; 
            this.joypad2 = joypad2;
			this.joypad3 = joypad3; 
            this.joypad4 = joypad4;
        }
        public void Update()
        {
            KeyboardState state = new KeyboardState(true);
			
            joypad1.A = state.IsKeyPressed(p1_A);
            joypad1.B = state.IsKeyPressed(p1_B);
            joypad1.Start = state.IsKeyPressed(p1_ST);
            joypad1.Select = state.IsKeyPressed(p1_SE);
            joypad1.Up = state.IsKeyPressed(p1_UP);
            joypad1.Down = state.IsKeyPressed(p1_DO);
            joypad1.Left = state.IsKeyPressed(p1_LF);
            joypad1.Right = state.IsKeyPressed(p1_RT);
			
			joypad2.A = state.IsKeyPressed(p2_A);
            joypad2.B = state.IsKeyPressed(p2_B);
            joypad2.Start = state.IsKeyPressed(p2_ST);
            joypad2.Select = state.IsKeyPressed(p2_SE);
            joypad2.Up = state.IsKeyPressed(p2_UP);
            joypad2.Down = state.IsKeyPressed(p2_DO);
            joypad2.Left = state.IsKeyPressed(p2_LF);
            joypad2.Right = state.IsKeyPressed(p2_RT);

	        joypad3.A = state.IsKeyPressed(p3_A);
            joypad3.B = state.IsKeyPressed(p3_B);
            joypad3.Start = state.IsKeyPressed(p3_ST);
            joypad3.Select = state.IsKeyPressed(p3_SE);
            joypad3.Up = state.IsKeyPressed(p3_UP);
            joypad3.Down = state.IsKeyPressed(p3_DO);
            joypad3.Left = state.IsKeyPressed(p3_LF);
            joypad3.Right = state.IsKeyPressed(p3_RT);
			
			joypad4.A = state.IsKeyPressed(p4_A);
            joypad4.B = state.IsKeyPressed(p4_B);
            joypad4.Start = state.IsKeyPressed(p4_ST);
            joypad4.Select = state.IsKeyPressed(p4_SE);
            joypad4.Up = state.IsKeyPressed(p4_UP);
            joypad4.Down = state.IsKeyPressed(p4_DO);
            joypad4.Left = state.IsKeyPressed(p4_LF);
            joypad4.Right = state.IsKeyPressed(p4_RT);

			if (vsunisystem!=null)
			{
			vsunisystem.CreditLeftCoinSlot=state.IsKeyPressed(vsu_CreditLeftCoinSlot);
			vsunisystem.CreditRightCoinSlot=state.IsKeyPressed(vsu_CreditRightCoinSlot);
			vsunisystem.CreditServiceButton=state.IsKeyPressed(vsu_CreditServiceButton);
			vsunisystem.DIPSwitch1=state.IsKeyPressed(vsu_DIPSwitch1);
			vsunisystem.DIPSwitch1=state.IsKeyPressed(vsu_DIPSwitch2);
			vsunisystem.DIPSwitch1=state.IsKeyPressed(vsu_DIPSwitch3);
			vsunisystem.DIPSwitch1=state.IsKeyPressed(vsu_DIPSwitch4);
			vsunisystem.DIPSwitch1=state.IsKeyPressed(vsu_DIPSwitch5);
			vsunisystem.DIPSwitch1=state.IsKeyPressed(vsu_DIPSwitch6);
			vsunisystem.DIPSwitch1=state.IsKeyPressed(vsu_DIPSwitch7);
			vsunisystem.DIPSwitch1=state.IsKeyPressed(vsu_DIPSwitch8);
			}
        }
    }
}
