﻿//  
//  soundSDL.cs
//  
//  Author:
//       Ala Hadid <ahdsoftwares@hotmail.com>
// 
//  Copyright (c) Ala Hadid 2011 
// 
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
using MyNes.Nes;
using MyNes.Nes.Output.Audio;

using SdlDotNet.Core;
using SdlDotNet.Audio;

namespace MyNesSDL
{
    class soundSDL:IAudioDevice
    {
		AudioStream stream;
	    AudioCallback callback;
		NesApu apu;

		public soundSDL(NesApu Apu, bool On)
		{
			
			apu = Apu;
			if (On)
			{
				try
				{
			callback = new AudioCallback(Unsigned16BigCallback);
			stream = new AudioStream(44100, AudioFormat.Unsigned16Big,
				SoundChannel.Mono,0,callback, "My Nes Sound");
		    stream.Paused = false;
				}
				catch(Exception ex)
				{
					Console.WriteLine(ex.ToString());
				}
			}
		}
	    void Unsigned16BigCallback(IntPtr userData, IntPtr stream, int len)
        {	
            len /= 2;
            int bufPos = 0;
			short[] buff = new short[len];
            while (bufPos < len)
            {
                buff[bufPos] = (short)apu.PullSample();
				bufPos++;
            }
			
            Marshal.Copy(buff, 0, stream, len);
			
            len = 0;
        }
        public IntPtr Handle
        {
            get { return IntPtr.Zero; }
        }

        public void UpdateBuffer()
        { 

		}

        public void Play()
        {
			if (stream !=null)
			{
				if ( stream.Paused )
	            stream.Paused = false;
			}
        }
		public void Stop()
		{
			Events.Poll();
		}
        public void Pause()
        {			
			if (stream !=null)
			{	
				if ( !stream.Paused )
                 stream.Paused = true;
			}
			Events.Poll();
        }

        public void Shutdown()
        {
			if (stream !=null)
			{
			stream.Paused = true;
			Events.CloseAudio();
			}
        }

        public void SetVolume(int Vol)
        {
      
        }

        public void SetPan(int Pan)
        {
        
        }

        public void Initialize()
        {
           
        }

        public MyNes.Nes.NesApu APU
        {
            get
            {
                return null;
            }
            set
            {

            }
        }

        public IWaveRecorder Recorder
        {
            get { return null; }
        }

        public int Volume
        {
            get { return 0; }
        }
    }
}
